//+------------------------------------------------------------------+
//|                                                       ATrade.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern double Lots = 0.01;
extern int Pips = 2;
extern double CheckProfit=0;  // ,     

int Slippage = 3;


int Order_Count[6];

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
Print(OT());
double p = countpr();
   double a1 = iCustom(Symbol(),5,"ASCTrend1sig",3 ,300, 0,1);
   double a2 = iCustom(Symbol(),5,"ASCTrend1sig",3,300,1,1);
   double a3 = iCustom(Symbol(),60,"ASCTrend1sig",3 ,300, 0,1);
   double a4 = iCustom(Symbol(),60,"ASCTrend1sig",3,300,1,1);
   
   double oop1 = 0, oop2 = 0;
   int actTotal = OrdersTotal(), TotalOrders, BuyOrders, SellOrders, BuyStop,SellStop;

   TotalOrders=Order_Count_Calculate(Symbol());
   
   if(TotalOrders >0) {
      if (p >= CheckProfit) oc();

      oop1=0;
      oop2=0;
      for(int i=0; i<OrdersTotal();i++) {
         if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
            if( OrderSymbol()==Symbol()) {
               if(OrderType()==OP_BUY) {BuyOrders++; oop1 = OrderOpenPrice();}
               if(OrderType()==OP_SELL) {SellOrders++; oop2 = OrderOpenPrice();}
               if(OrderType()==OP_BUYSTOP) BuyStop++;
               if(OrderType()==OP_SELLSTOP) SellStop++;
            }
         }
      }   

      //  
      if(BuyOrders > 0 && SellStop ==0) {
         double pBid=oop1-(Pips*Point);
         OrderSend(Symbol(),OP_SELLSTOP,2*Lots,pBid,Slippage,NULL,NULL,"",0,0,Red);
      }
      if(SellOrders > 0 && BuyStop ==0) {
         double pAsk=oop2+Pips*Point;
         OrderSend(Symbol(),OP_BUYSTOP,2*Lots,pAsk,Slippage,NULL,NULL,"",0,0,Blue);
      }
   }

   TotalOrders=Order_Count_Calculate(Symbol());
   if(TotalOrders ==0) {
      if(a2 > 0) OrderSend(Symbol(),OP_BUY,Lots,Ask,3,NULL,NULL,"",0,0,Blue);
      if(a1 > 0) OrderSend(Symbol(),OP_SELL,Lots,NULL,NULL,"",0,0,Red);
   } 
        
   return(0);
  }
  
  int countpr()
  {
 double pr = 0, oop1 = 0, oop2 = 0;
  int actTotal, BuyOrders, SellOrders;
  for(int i=0; i<actTotal;i++)
  {
      
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      if( OrderSymbol()==Symbol())
      {
      if(OrderType()==OP_BUY) {BuyOrders++; oop1 = (Bid - OrderOpenPrice())/Point*OrderLots();}
      if(OrderType()==OP_SELL) {SellOrders++; oop1 = (OrderOpenPrice() - Ask)/Point*OrderLots();
      pr+= oop1;
      }
    }
  }
}      
return(pr);
}
 
 void oc()
{
   int slippage=2;
   for (int i=OrdersTotal()-1; i>=0; i--)
   {
      if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) break;
      if (OrderType()==OP_BUY ) OrderClose (OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),slippage);
      if (OrderType()==OP_SELL) OrderClose (OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),slippage);
      if (OrderType()>OP_SELL)  OrderDelete(OrderTicket());
   }
 }
   
 int OT()
  {
datetime oct;
int pos_type=-1;
int j=-1, pr = 0, a = 0;
{
for(int i=OrdersTotal()-1;i>=0;i--){
   if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) continue;  
   if(OrderSymbol()!=Symbol())continue;
   { 
   if (oct<OrderOpenTime()) { oct=OrderCloseTime(); j=i;}           
   if (OrderSelect(j, SELECT_BY_POS, MODE_HISTORY)) 
      {
      pr = OrderType();
      }}}}
      if(pr == OP_BUY) a = 1;
      if(pr == OP_SELL) a = 2;
      return(a);
      }
// End
//+------------------------------------------------------------------+



//===============================================================================
//          
//===============================================================================
int Order_Count_Calculate(string lsSymbol="", int lnMagicNumber=-1, int OP=-1){
   int Count=0;
   ArrayInitialize(Order_Count,0);
   for (int i = OrdersTotal() - 1;  i >= 0;  i--) {
      if (!CheckOrder(i, lsSymbol, lnMagicNumber))  continue;
      if (OrderType()!=OP && OP!=-1)                continue;
      Order_Count[OrderType()]++;
      Count++;
   }
   if (OP!=-1) return(Order_Count[OP]);
   return(Count);
}

//===============================================================================
//       
//===============================================================================

bool CheckOrder(int lnPos,string lsSymbol="", int lnMagicNumber=-1) {
   if (!OrderSelect(lnPos,SELECT_BY_POS))           return(false);
   if (!(OrderSymbol()==lsSymbol || lsSymbol==""))  return(false);
   if (!(OrderMagicNumber()==lnMagicNumber || lnMagicNumber==-1))   return(false);
   return(true);
}